scala.tools.nsc.backend.icode

# TypeKinds

#### trait TypeKinds extends AnyRef

Self Type
  ICodes
Source
  TypeKinds.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
ICodes, icodes
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TypeKinds
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### final case class ARRAY(elem: ICodes.TypeKind) extends ICodes.TypeKind with Product with Serializable

2. #### case class BOXED(kind: ICodes.TypeKind) extends ICodes.TypeKind with Product with Serializable

   A boxed value.

3. #### final case class REFERENCE(cls: Global.Symbol) extends ICodes.TypeKind with Product with Serializable

   A class type.

4. #### sealed abstract class TypeKind extends AnyRef

   This class represents a type kind.

   This class represents a type kind. Type kinds represent the types that the VM know (or the ICode view of what VMs know).

5. #### sealed abstract class ValueTypeKind extends ICodes.TypeKind

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TypeKinds to any2stringadd[TypeKinds] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (TypeKinds, B)

   Implicit information
     This member is added by an implicit conversion from TypeKinds to ArrowAssoc[TypeKinds] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def ArrayN(elem: ICodes.TypeKind, dims: Int): ICodes.ARRAY

7. #### object BOOL extends ICodes.ValueTypeKind with Product with Serializable

   A boolean value

8. #### object BYTE extends ICodes.ValueTypeKind with Product with Serializable

   A 1-byte signed integer

9. #### object CHAR extends ICodes.ValueTypeKind with Product with Serializable

   A 2-byte UNSIGNED integer

10. #### object ConcatClass extends ICodes.TypeKind with Product with Serializable

    Dummy TypeKind to represent the ConcatClass in a platform-independent way.

    Dummy TypeKind to represent the ConcatClass in a platform-independent way. For JVM it would have been a REFERENCE to 'StringBuffer'.

11. #### object DOUBLE extends ICodes.ValueTypeKind with Product with Serializable

    An 8-byte floating point number

12. #### object FLOAT extends ICodes.ValueTypeKind with Product with Serializable

    A 4-byte floating point number

13. #### object INT extends ICodes.ValueTypeKind with Product with Serializable

    A 4-byte signed integer

14. #### object LONG extends ICodes.ValueTypeKind with Product with Serializable

    An 8-byte signed integer

15. #### object SHORT extends ICodes.ValueTypeKind with Product with Serializable

    A 2-byte signed integer

16. #### object UNIT extends ICodes.ValueTypeKind with Product with Serializable

    The unit value

17. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

18. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

19. #### def ensuring(cond: (TypeKinds) ⇒ Boolean, msg: ⇒ Any): TypeKinds

    Implicit information
      This member is added by an implicit conversion from TypeKinds to Ensuring[TypeKinds] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: (TypeKinds) ⇒ Boolean): TypeKinds

    Implicit information
      This member is added by an implicit conversion from TypeKinds to Ensuring[TypeKinds] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean, msg: ⇒ Any): TypeKinds

    Implicit information
      This member is added by an implicit conversion from TypeKinds to Ensuring[TypeKinds] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### def ensuring(cond: Boolean): TypeKinds

    Implicit information
      This member is added by an implicit conversion from TypeKinds to Ensuring[TypeKinds] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

23. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

24. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

25. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

26. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from TypeKinds to StringFormat[TypeKinds] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

27. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

28. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

29. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

30. #### def lub(a: ICodes.TypeKind, b: ICodes.TypeKind): ICodes.TypeKind

    The least upper bound of two typekinds.

    The least upper bound of two typekinds. They have to be either REFERENCE or ARRAY kinds.

    The lub is based on the lub of scala types.

31. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

32. #### final def notify(): Unit

    Definition Classes
      AnyRef

33. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

34. #### lazy val primitiveTypeMap: Map[Global.Symbol, ICodes.TypeKind]

    A map from scala primitive Types to ICode TypeKinds

35. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

36. #### def toString(): String

    Definition Classes
      AnyRef → Any

37. #### def toTypeKind(t: Global.Type): ICodes.TypeKind

    Return the TypeKind of the given type

    Return the TypeKind of the given type

    Call to dealiasWiden fixes #3003 (follow type aliases). Otherwise, arrayOrClassType below would return ObjectReference.

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### def →[B](y: B): (TypeKinds, B)

    Implicit information
      This member is added by an implicit conversion from TypeKinds to ArrowAssoc[TypeKinds] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TypeKinds to any2stringadd[TypeKinds]

### Inherited by implicit conversion StringFormat from TypeKinds to StringFormat[TypeKinds]

### Inherited by implicit conversion Ensuring from TypeKinds to Ensuring[TypeKinds]

### Inherited by implicit conversion ArrowAssoc from TypeKinds to ArrowAssoc[TypeKinds]

### Ungrouped